﻿//---------------------------------------------------------------------------
// MPIHelloWorld.cpp
//---------------------------------------------------------------------------
#if (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	#include <sys/types.h>
	#include <sys/stat.h>
	#include <unistd.h>
#elif (defined _WIN32) || (defined _WIN64)
	#include <conio.h>
	#include <direct.h>
#endif

#include "mpi.h"
#include <stdlib.h>
#include <iostream>
using namespace std;

int main(int argc, char* argv[])
{
	int size, rank;

	MPI_Init(&argc, &argv);
	MPI_Comm_size(MPI_COMM_WORLD, &size);
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	if (rank == 0) {
		cout << "There are " << size << " processes\n";
		std::fflush(stdout);
	}
	if (rank == 0) {
		char helloStr0[] = "Hello World";
		MPI_Send(helloStr0, 12, MPI_CHAR, 1, 0, MPI_COMM_WORLD);
	}
	else if (rank == 1) {
		char helloStr1[12];
		MPI_Recv(helloStr1, 12, MPI_CHAR, 0, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
		printf("\nProcess 1 has received string \"%s\" from process 0.\n", helloStr1);
	}

	MPI_Finalize();
	return 0;
}